"""
Our autogenerated schemas aren't perfect. This file contains overrides for the autogenerated schemas for things it
doesn't handle well. We also have additional classes not generated at all in schema_extras.py..
"""
from pydantic import field_validator
from pydantic_core.core_schema import FieldValidationInfo

from .generated import schemas as generated_schemas


class RequestedRequirement(generated_schemas.RequestedRequirement):
    # Pin must be present iff version is present
    @field_validator("pin")
    def pin_must_be_present_iff_version_is_present(cls, v: str | None, info: FieldValidationInfo) -> object:
        if v is None and info.data.get("version") is not None:
            raise ValueError("pin must be present if version is present")
        if v is not None and info.data.get("version") is None:
            raise ValueError("version must be present if pin is present")
        return v

    def as_str(self) -> str:
        if self.pin is None or self.version is None:
            return self.library
        return f"{self.library}{self.pin}{self.version}"

    def __str__(self) -> str:
        return self.as_str()


class RequestedAptPackage(generated_schemas.RequestedAptPackage):
    name: str

    def __str__(self) -> str:
        return self.name
